package arm;

import iron.object.Object;
import armory.trait.physics.RigidBody;
import iron.math.Vec4;

class Player extends iron.Trait {

	var input:Input;
	var hb:Object;//hitbox
	//orientation vectors
	var up:Vec4;
	var look:Vec4;
	var right:Vec4;

	var vec:Vec4;//*
	
	var velocity:Vec4;
	var sp:Float;//speed
	var msp:Float;
	var hsp:Float;
	var fsp:Float;
	var a:Float;//acceleration
	var sensitivity:Float;

	public function new() {
		super();

		 notifyOnInit(function() {
			input = new Input();
			hb = object.getChild("Hitbox");
			up = new Vec4(0,0,1,0);
			input.ms.lock();
			input.ms.hide();
			velocity = new Vec4();
			a = 6;//acceleration
			msp = 24;//speed
			hsp = 0;
			fsp = 0;
			sensitivity = 0.004;

		 });

		 notifyOnUpdate(function() {
			 input.updateIn();
			 //look
			 object.transform.rotate(up, input.mx * -0.004);
			 object.getChild("Camera").transform.rotate(Vec4.xAxis(), input.my * -sensitivity);	 
			 //move	
			 #if arm_physics
			 var rb = object.getTrait(RigidBody);
			 if (input.up && !input.down)
				fsp += a;
			else if (!input.up && input.down)
				fsp -= a;
			if (!input.left && input.right)
				hsp += a;
			else if (input.left && !input.right)
				hsp -= a;
			if (fsp > msp)
				fsp = msp;			
			if (hsp > msp)
				hsp = msp;
			if (fsp < -msp)
				fsp = -msp;			
			if (hsp < -msp)
				hsp = -msp;

			look = object.transform.world.look().mult(fsp);
			right = object.transform.world.right().mult(hsp);
			velocity.set(look.x + right.x, look.y + right.y, 0, 0);
			velocity.normalize();
			sp = Math.sqrt(hsp*hsp + fsp*fsp);
			velocity.mult(sp);

			rb.setLinearVelocity(velocity.x, velocity.y, rb.getLinearVelocity().z);
			if (!input.up && !input.down){
				if (fsp > a/2) fsp -= a; else if (fsp < -a/2) fsp += a; else fsp = 0;
			}
			if (!input.right && !input.left){
				if (hsp > a/2) hsp -= a; else if (hsp < -a/2) hsp += a; else hsp = 0;
			}
			
			object.transform.buildMatrix();
			if (rb != null) rb.syncTransform();
			 #end
			//debug
			if (input.esc)
				kha.System.stop();
			if (input.shift){
				input.ms.unlock();
				input.ms.show();}
			else{ 
				input.ms.lock();
				input.ms.hide();}
		 });

		// notifyOnRemove(function() {
		// });
	}
}
